#ifndef _SHAREDPTR_H_
#define _SHAREDPTR_H_

#include "GaussNumber.h"
#define NULL 0

class Storage {

private:
	GaussNumber *p_obj;
	int count;

public:
	Storage(GaussNumber *p_obj);
	~Storage();
	void increaseCount();
	void decreaseCount();
	GaussNumber *ptr() const;
	bool isNull() const;

};


class shared_ptr {

private:
	Storage *storage;

public:
	shared_ptr();
	shared_ptr(GaussNumber *p_obj);
	shared_ptr(const shared_ptr &sptr);
	~shared_ptr();
	const shared_ptr &operator=(const shared_ptr &sptr);
	GaussNumber &operator*() const;
	GaussNumber *operator->() const;
	GaussNumber *ptr() const;
	bool isNull() const;

};

#endif
